
// HomeDlg.cpp: 实现文件
//

#include "pch.h"
#include "framework.h"
#include "回原点运动.h"
#include "HomeDlg.h"
#include "afxdialogex.h"
#include"MC_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CHomeDlg 对话框



CHomeDlg::CHomeDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MY_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	startVel = 500;
	maxVel = 2000;
	stopVel = 500;
	tAcc = 0.1;
	tDec = 0.1;
	sRatio = 0;
	maxAcc = 1000000;
}

void CHomeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT1, startVel);
	DDX_Text(pDX, IDC_EDIT2, maxVel);
	DDX_Text(pDX, IDC_EDIT3, stopVel);
	DDX_Text(pDX, IDC_EDIT4, tAcc);
	DDX_Text(pDX, IDC_EDIT5, tDec);
	DDX_Text(pDX, IDC_EDIT6, sRatio);
	DDX_Text(pDX, IDC_EDIT7, maxAcc);

	DDX_Control(pDX, IDC_COMBO1, axisNoCombobox);

	DDX_Control(pDX, IDC_STATICELP, ELPState);
	DDX_Control(pDX, IDC_STATICELN, ELNState);
	DDX_Control(pDX, IDC_STATICORG, ORGState);
	DDX_Control(pDX, IDC_COMBO2, homePosObject);
	DDX_Control(pDX, IDC_COMBO3, homeLogic);
	DDX_Control(pDX, IDC_COMBO4, homeDir);
	DDX_Control(pDX, IDC_COMBO5, homeStopMode);
	DDX_Control(pDX, IDC_COMBO6, homeMode);
	DDX_Control(pDX, IDC_EDIT8, homeOffset);
	DDX_Control(pDX, IDC_EDIT9, homeEzCount);
}

BEGIN_MESSAGE_MAP(CHomeDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, &CHomeDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CHomeDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CHomeDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON1, &CHomeDlg::OnBnClickedButton1)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CHomeDlg 消息处理程序

BOOL CHomeDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码
#pragma region 开卡
	WORD pciNum = 0; //用于接收开卡成功的卡数
	WORD pcieIndex[12];
	DWORD functionReturn = 0; //函数返回值

	functionReturn = MC_Open(0, CONNECTION_PCI, "", &pciNum, pcieIndex);
	if (functionReturn == 0)//函数成功执行
	{
		if (pciNum > 0)//至少一张卡被成功开卡
		{
			cardConnectNo = pcieIndex[0]; //如果有多卡的情况下这里也只用卡1演示

#pragma region 获取卡信息
			//--------------------------获取卡信息------------------------------------------------------------------------
			WORD totalAxisNum = 0; //用于获取卡的轴数
			WORD linerNum = 0;//用于获取卡的插补系个数
			WORD totalInNum = 0;//用于获取卡的输入口数量
			WORD totalOutNum = 0;//用于获取卡的输出口数量
			WORD totalPWMNum = 0;//用于获取卡的PWM通道数量
			functionReturn = MC_GetTotalAxesAndIONum(cardConnectNo, &totalAxisNum, &linerNum, &totalInNum, &totalOutNum, &totalPWMNum);
			for (int axisNo = 0; axisNo < totalAxisNum; axisNo++)
			{
				CString str;
				str.Format(_T("%d"), axisNo);
				axisNoCombobox.AddString(str);
			}
			axisNoCombobox.SetCurSel(0);//设置轴号ComboBox默认选择

			homePosObject.AddString(L"指令位置");
			homePosObject.AddString(L"反馈位置");

			homeLogic.AddString(L"低电平");
			homeLogic.AddString(L"高电平");

			homeDir.AddString(L"正方向");
			homeDir.AddString(L"负方向");

			homeStopMode.AddString(L"回零后不做任何动作");
			homeStopMode.AddString(L"回零之后清零, 然后偏移");
			homeStopMode.AddString(L"回零之后偏移, 然后清零");

			homeMode.AddString(L"0无效回零方式");
			homeMode.AddString(L"1-一次捕获ORG信号回零");
			homeMode.AddString(L"2 - 高速运动 + 反向一次捕获ORG信号");
			homeMode.AddString(L"3 - 高速运动 + 同向低速捕获ORG信号回零");
			homeMode.AddString(L"4 - ORG + 反向找EZ捕获回零");
			homeMode.AddString(L"5 - ORG + 运动方向EZ捕获回零");
			homeMode.AddString(L"6 - EZ捕获回零");
			homeMode.AddString(L"7 - 单次限位回零");
			homeMode.AddString(L"8 - 两次限位回零");
			homeMode.AddString(L"9 - 多次限位回零");

			WORD _posObject = 0;
			WORD _homeMode = 0;
			int _homeDir = 0;
			WORD _homeLogic = 0;
			WORD _ezCount = 0;
			WORD _offsetMode = 0;
			double _posOffset = 0;
			MC_GetHomePrm(cardConnectNo, axisNoCombobox.GetCurSel(), &_posObject, &_homeMode, &_homeDir, &_homeLogic, &_ezCount, &_offsetMode, &_posOffset);
			homePosObject.SetCurSel(_posObject);
			homeLogic.SetCurSel(_homeLogic);
			if (_homeDir < 0)homeDir.SetCurSel(1);
			else homeDir.SetCurSel(_homeDir);
			homeStopMode.SetCurSel(_offsetMode);
			homeMode.SetCurSel(_homeMode);

			CString posOffsetStr;
			posOffsetStr.Format(_T("%f"), _posOffset);
			GetDlgItem(IDC_EDIT8)->SetWindowTextW(posOffsetStr); //回零偏移设置到界面

			CString ezCountStr;
			ezCountStr.Format(_T("%d"), _ezCount);
			GetDlgItem(IDC_EDIT9)->SetWindowTextW(ezCountStr); //ez回零ez计数设置到界面
			//------------------------------------------------------------------------------------------------------------
#pragma endregion
			SetTimer(1, 200, NULL);//启动界面监控定时器

		}
		else
		{
			MessageBox(L"未找到卡!");
		}
	}
	else
	{
		MessageBox(L"开卡失败!");
	}
#pragma endregion

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CHomeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CHomeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}

}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CHomeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/// <summary>
/// 界面执行运动按钮点击事件
/// </summary>
void CHomeDlg::OnBnClickedButton2()
{
	// TODO: 在此添加控件通知处理程序代码
	UpdateData(true); //用于将屏幕上控件中的数据交换到变量中

	WORD axisNo = axisNoCombobox.GetCurSel(); //需要运动的轴号

	WORD _posObject = homePosObject.GetCurSel(); //锁存回零的锁存位置模式
	WORD _home_mode = homeMode.GetCurSel(); //回零模式
	int _home_dir = 1; //回零方向
	if (homeDir.GetCurSel() < 0)_home_dir = -1;

	WORD _home_logic = homeLogic.GetCurSel();//原点信号有效电平

	WORD _ezCount = 1;//ez回零计EZ信号的个数
	CString ezCountStr;
	GetDlgItem(IDC_EDIT9)->GetWindowTextW(ezCountStr);
	ezCountStr.Format(_T("%d"), _ezCount);//获取界面上的ez回零ez计数个数

	WORD _offset_mode = homeStopMode.GetCurSel();//回零结束模式

	double _offset = 0;//回零结束偏移
	CString offsetStr;
	GetDlgItem(IDC_EDIT8)->GetWindowTextW(offsetStr);
	offsetStr.Format(_T("%f"), _offset);


	MC_Power(cardConnectNo, axisNo, 1); //轴使能，轴使能之后才能够通过指令启动运动发出脉冲

	//先设置轴的运动参数
	MC_SetAxisMotionPrm(cardConnectNo, axisNo, startVel, maxVel, stopVel, tAcc, tDec, sRatio, maxAcc);

	//启动运动
	//参数三，pos_mode = 0时为相对运动模式， = 1时为绝对运动模式
	MC_Home(cardConnectNo, axisNo, _posObject,
		_home_mode,
		_home_dir,
		_home_logic,
		_ezCount,
		_offset_mode,
		_offset);

	UpdateData(false);//用于将数据在屏幕中对应控件中显示出来

}

/// <summary>
/// 停止按钮点击触发的事件
/// </summary>
void CHomeDlg::OnBnClickedButton3()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号

	//参数三，stop_mode = 0时停止模式为减速停止，=1时为立即停止
	//参数四，stop_time为减速停止时的减速时间
	MC_StopAxis(cardConnectNo, axisNo, 0, 0.1);
}


/// <summary>
/// 紧急停止按钮点击触发的事件
/// </summary>
void CHomeDlg::OnBnClickedButton4()
{
	// TODO: 在此添加控件通知处理程序代码
	MC_StopEmgImd(cardConnectNo); //急停函数，所有轴立即停止

}

/// <summary>
/// 位置清除按钮点击触发的事件
/// </summary>
void CHomeDlg::OnBnClickedButton1()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	MC_SetAxisCmdPos(cardConnectNo, axisNo, 0);//指令位置清零
}


void CHomeDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: 在此处添加消息处理程序代码
	KillTimer(1);
	MC_Close(cardConnectNo); //关卡释放资源
}


void CHomeDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: 在此添加消息处理程序代码和/或调用默认值
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	double cmdPos = 0;
	MC_GetAxisCmdPos(cardConnectNo, axisNo, &cmdPos);//获取当前指令位置
	CString cmdPosStr;
	cmdPosStr.Format(_T("%f"), cmdPos);
	GetDlgItem(IDC_EDIT11)->SetWindowTextW(cmdPosStr); //设置到界面

	double cmdSpeed = 0;
	MC_GetAxisCmdSpeed(cardConnectNo, axisNo, &cmdSpeed); //获取当前指令速度
	CString cmdSpeedStr;
	cmdSpeedStr.Format(_T("%f"), cmdSpeed);
	GetDlgItem(IDC_EDIT10)->SetWindowTextW(cmdSpeedStr); //设置到界面

	WORD checkDone = 1;
	MC_GetAxisCheckDone(cardConnectNo, axisNo, &checkDone);//获取轴运动状态
	switch (checkDone)
	{
	case 0:
		GetDlgItem(IDC_EDIT12)->SetWindowTextW(L"运动中");
		break;
	case 1:
		GetDlgItem(IDC_EDIT12)->SetWindowTextW(L"空闲");
		break;
	default:
		CString checkDoneStr;
		checkDoneStr.Format(_T("%d"), checkDone);
		GetDlgItem(IDC_EDIT12)->SetWindowTextW(checkDoneStr);
		break;
	}

	WORD homeResult = 0;
	MC_GetHomeResult(cardConnectNo, axisNo, &homeResult); //获取回零结果
	switch (homeResult)
	{
	case 0:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零未完成");
		break;
	case 1:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零完成");
		break;
	case 2:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零出错，没有原点信号");
		break;
	case 3:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零中发现两个原点信号");
		break;
	case 4:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零中没有发现EZ信号");
		break;
	case 5:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零配置的方向错误");
		break;
	case 6:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零过程限位停止");
		break;
	case 7:
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(L"回零外部停止");
		break;
	default:
		CString homeResultStr;
		homeResultStr.Format(_T("%d"), homeResult);
		GetDlgItem(IDC_EDIT13)->SetWindowTextW(homeResultStr);
		break;
	}

	DWORD inioState = 0;
	MC_GetAxisInIoState(cardConnectNo, axisNo, &inioState);//获取轴专用IO状态
	//负限位
	bool state = false;
	state = (inioState & (DWORD)0x1) > 0 ? true : false;
	if (state) ELNState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONRED));
	else ELNState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONGREEN));

	//正限位
	state = ((inioState >> 1) & (DWORD)0x1) > 0 ? true : false;
	if (state) ELPState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONRED));
	else ELPState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONGREEN));

	//原点
	state = ((inioState >> 2) & (DWORD)0x1) > 0 ? true : false;
	if (state) ORGState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONRED));
	else ORGState.SetIcon(AfxGetApp()->LoadIcon(IDI_ICONGREEN));
	CDialogEx::OnTimer(nIDEvent);
}
